package cn.net.cpzslibs.prot;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.bean.req.Prot10046LabelBean;
import cn.net.cpzslibs.prot.bean.res.Prot10046ResultBean;
import cn.net.cpzslibs.prot.utils.StrUtils;


public class Prot10046Label extends ProtBase {
	/**
	 * 是否成功
	 */
	private short iResult;
	
	private final short iTaskCode10016 = 10046;
	private Gson gson;
	private Prot10046ResultBean labelResult;
	
	public Prot10046Label() {
//		this.sInspectorId = sInspectorId;
		gson = new Gson();
	}
	
	/*public String getJsonData() {
		return jsonData;
	}*/
	public Prot10046ResultBean getLabelResult(){
		return this.labelResult;
	}
	
	public void dealLabelList(SocketCreate create, Prot10046LabelBean labelBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), labelBean);
	}
	
	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis, Prot10046LabelBean labelBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				//发送登录信息
				debugLog(iTaskCode10016, "开始请求产品列表");
				sendProt(dos, labelBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recLoginDis(dis);
			}
		}
	}
	
	/**
	 * 读取JSon数据
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode10016, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode10016, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			labelResult = gson.fromJson(jsonData, Prot10046ResultBean.class);
		}
		recCheckCode(dis);
	}
	
	
	/**
	 * 发送JSon数据到服务器
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Prot10046LabelBean labelBean) throws IOException {
		String bodyContent = gson.toJson(labelBean).toString();
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode10016, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
//		sendCheckCode(dos);
		sendCheckCoded(dos,bodyContent.getBytes("UTF-8"));
	}
	

}
